<?php
/*
	Plugin Name: CaptchaFA
	Version: 2.1
	Author: Ehsan F.
	Author URI: http://wp-tricks.ir/captchafa
	Plugin URI: http://www.captchafa.com
	Description: این افزونه به شما کمک می کند تا از سیستم کپچافا در قسمت های مختلف وردپرس از جمله قسمت ارسال دیدگاه و نام نویسی به راحتی استفاده کنید. قبل از فعال کردن افزونه ابتدا یک کلید از <a href="http://www.captchafa.com/getkey.php">اینجا</a> دریافت کنید.
*/
//--------------------------------------------------\\
/*  Copyright 2012  Ehsan F.  (email : iehsan.ir@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Special Thanks to :
	* CaptchaFA team (www.captchafa.com)
	* Mohammad Majidi (www.persianscript.ir)
	* Persian WordPress team (wp-persian.com)
	* My Parents and my dear brother: Mojtaba (mojtabaforghani.blogfa.com)
	* and anyone help me to make this plugin...
*/
//--------------------------------------------------\\
/**
  * @package WordPress
  * @subpackage CaptchaFA
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version 2.1
 */
//--------------------------------------------------\\
/**
  * Include required library
  * @since Version 1.0
 */
require_once("lib/captchafalib.php");
//--------------------------------------------------\\
/**
  * Actions
  * @since Version: 2.0
 */
if (is_admin())
{
	add_action("admin_init", "admin_register_settings");
	add_action("admin_menu", "admin_menu");
	add_action("admin_notices", "admin_warning");
}
if (get_option("showCaptchaForComments") == 'on') {
	add_action("comment_form", "showCaptcha");
	add_action("pre_comment_on_post", "checkAnswer");
}
if (get_option("showCaptchaForSignup") == "on") {
	add_action("register_form", "showCaptcha");
	add_action("user_register", "checkAnswer");
}
if (get_option("showCaptchaForLogin") == "on") {
	add_action("login_form", "showCaptcha");
	add_action("wp_authenticate", "checkAnswerL");
}
//--------------------------------------------------\\
/**
  * Admin action functions
  * @since Version: 2.1
**/
/**
  * Register admin settings
  * @since Version: 1.0
 */
function admin_register_settings()
{
	register_setting('captchafa', 'showCaptchaForComments');
	register_setting('captchafa', 'showCaptchaForSignup');
	register_setting('captchafa', 'showCaptchaForLogin');
	register_setting('captchafa', 'publicKey');
	register_setting('captchafa', 'privateKey');
}
/**
  * Add admin configuration menu item
  * @return bool
  * @since Version: 1.0
 */
function admin_menu()
{
	return add_menu_page(
		"کپچافا",
		"کپچافا",
		"activate_plugins",
		"captchafa",
		"admin_page"
	);
}
function admin_warning()
{
	$puk = get_option('publicKey');
	$prk = get_option('privateKey');
	
	if (is_null($puk)) {
		echo '<div class="updated"><p>کپچافا آماده است، برای شروع کار کلیدهای خود را در <a href="admin.php?page=captchafa">اینجا</a> بنویسید.</p></div>';
	} elseif (is_null($prk)) {
		echo '<div class="updated"><p>کپچافا آماده است، برای شروع کار کلیدهای خود را در <a href="admin.php?page=captchafa">اینجا</a> بنویسید.</p></div>';
	}
}
/**
  * Admin config page
  * @return mixed
  * @since Version: 1.0
 */
function admin_page()
{
	$logo_uri[0] = plugins_url('img/captchafa.png', __FILE__);
	$logo_uri[1] = plugins_url('img/tricks.png', __FILE__);
?>
	<div class="wrap">
	<?php if ($_GET['settings-updated'] == 'true') { ?>
		<div id="message" class="updated"><p>پیکربندی بروز شد!</p></div>
	<?php } ?>
		<p style="text-align: center;">
			<a href="http://www.captchafa.com"><img src="<?php echo $logo_uri[0]; ?>" alt="CaptchaFA"></a>
			<span style="margin-left: 10px;"></span>
			<a href="http://wp-tricks.ir"><img src="<?php echo $logo_uri[1]; ?>" alt="WP-Tricks"></a>
		</p>
		<p><h2 style="font: 20pt 'B Mitra',traffic,arial;font-weight: normal;">پیکربندی کپچافا</h2></p>
		<form method="post" action="options.php">
			<?php settings_fields('captchafa'); ?>
			<?php do_settings_fields( 'captchafa', 'captchafa' ); ?>
			<table class="form-table">
				<tr valign="top">
					<th scope="row">کلید عمومی</th>
					<td><input class="widefat" type="text" name="publicKey" value="<?php echo get_option("publicKey"); ?>"></td>
				</tr>
				<tr valign="top">
					<th scope="row">کلید خصوصی</th>
					<td><input class="widefat" type="text" name="privateKey" value="<?php echo get_option("privateKey"); ?>"></td>
				</tr>
				<tr valign="top"><th scope="row"></th><td>از طریق <a href="http://www.captchafa.com/getkey.php">این سامانه</a> میتوانید این دو کلید را دریافت کنید</td></tr>
				<tr valign="top">
					<th scope="row">نمایش کپچا در قسمت ارسال نظر</th>
					<td><input type="checkbox" name="showCaptchaForComments" <?php if (get_option("showCaptchaForComments") == "on") echo "checked"; ?>></td>
				</tr>
				<tr valign="top">
					<th scope="row">نمایش کپچا در قسمت نام نویسی</th>
					<td><input type="checkbox" name="showCaptchaForSignup" <?php if (get_option("showCaptchaForSignup") == "on") echo "checked"; ?>></td>
				</tr>
				<tr valign="top">
					<th scope="row">نمایش کپچا در قسمت ورود</th>
					<td><input type="checkbox" name="showCaptchaForLogin" <?php if (get_option("showCaptchaForLogin") == "on") echo "checked"; ?>></td>
				</tr>
				<tr valign="top">
					<td><?php submit_button(); ?></td>
				</tr>
			</table>
		</form>
	</div>
<?php
}
/**
  * Captcha functions
  * @since Version: 2.1
 */
/**
  * Display captcha form
  * @since Version: 2.0
 */
function showCaptcha()
{
	$publicKey = get_option("publicKey");
	echo captchafa_get_html($publicKey);
}
/**
  * Check captcha answer
  * @param mixed[]
 */
function checkAnswer()
{
	$privateKey = get_option("privateKey");
	$resp = captchafa_check_answer ($privateKey,
									$_SERVER["REMOTE_ADDR"],
									$_POST["captchafa_challenge_field"],
									$_POST["captchafa_response_field"]);
	if (!$resp->is_valid) {
		wp_die("کپچای وارد شده صحیح نمی باشد");
		exit;
	} else {
		return;
	}
}
function checkAnswerL()
{
	$privateKey = get_option("privateKey");
	if ($_POST["captchafa_challenge_field"]) {
	$resp = captchafa_check_answer ($privateKey,
									$_SERVER["REMOTE_ADDR"],
									$_POST["captchafa_challenge_field"],
									$_POST["captchafa_response_field"]);
	if (!$resp->is_valid) {
		wp_die("کپچای وارد شده صحیح نمی باشد");
		exit;
	} else {
		return;
	}
	}
}
?>